<?php
//define this module's name and path
$mn = "odyssey_flipbook";
include("modules/modules.php");

/*
Available variables:
All system classes
All request variables
$p (the template path)
$mp (the module path)
$sufixID (id sufix for this module's divs)
*/

$folderName = $moduleParameters["folderName"];
$pdf = (is_file("mediabank/$folderName/$folderName.pdf")) ? str_replace(' ', '%20', "mediabank/$folderName/$folderName.pdf") : false;
$pages = $large_pages = $thumbs = array();
if (!trim($folderName)) { // try mediabank
    $imageFiles = explode(",", $moduleParameters["imageFiles"]);
    foreach ($imageFiles as $page) {
        $pages[] = "mediabank/medium/medium_" . $page;
        $large_pages[] = "mediabank/images/" . $page;
        $thumbs[] = "mediabank/thumbs/small_" . $page;
    }
} else { // use images from defined folder
    $mediumImageFiles = glob("mediabank/" . $folderName . "/medium/medium*.jpg");
    sort($mediumImageFiles, SORT_NATURAL);
    foreach ($mediumImageFiles as $img) {
        $pages[] = $img;
    }
    $largeImageFiles = glob("mediabank/" . $folderName . "/images/image*.jpg");
    sort($largeImageFiles, SORT_NATURAL);
    foreach ($largeImageFiles as $img) {
        $large_pages[] = $img;
    }
    $thumbImageFiles = glob("mediabank/" . $folderName . "/thumbs/thumb*.jpg");
    sort($thumbImageFiles, SORT_NATURAL);
    foreach ($thumbImageFiles as $img) {
        $thumbs[] = $img;
    }
    $imageFiles = $largeImageFiles;
}

if (!count($imageFiles)) {
    $messages->addError("No content for flipbook defined");
    $messages->printErrorMessages();
    return;
}

$useModuleContainer = true; // this module requires a module container
$pageWidth = $moduleParameters["pageWidth"];
$pageHeight = $moduleParameters["pageHeight"];
$bookDescription = $moduleParameters["bookDescription"];
$backgroundColor = $moduleParameters['backgroundColor'];
$showThumbnails = ($moduleParameters['showThumbnails'] == "__EMPTY__" || empty($moduleParameters['showThumbnails'])) ? false : true;
$autoLoad = ($moduleParameters['autoLoad'] == "__EMPTY__" || empty($moduleParameters['autoLoad'])) ? false : true;


if ($useModuleContainer){
?>
<div id="<?php echo $mn . $sufixID; ?>" data-editable="editable" class="responsive_float">
    <?php
    }
    if ($openflipbook == $currentModuleID) {
        global $head_styles;
        ob_start();
        ?>
        <style>
            /* css overrides */
            .flipbook-viewport .container {
                width: <?php echo $pageWidth*2;?>px;
                height: <?php echo $pageHeight;?>px;
            }

            .flipbook-viewport .flipbook {
                width: <?php echo $pageWidth*2;?>px;
                height: <?php echo $pageHeight;?>px;
                left: -<?php echo $pageWidth;?>px;
                top: 100px;
            }

            .flipbook-viewport .page {
                width: <?php echo $pageWidth;?>px;
                height: <?php echo $pageHeight;?>px;
            }

            .flipbook-viewport .next-button,
            .flipbook-viewport .previous-button {
                height: <?php echo $pageHeight;?>px;
            }

            .flipbook_pdf_download{
                position: absolute;
                display:block;
                width: 50px;
                height:50px;
                top:7px;
                right:-100px;
                z-index: 9999;
            }

            <?php
            if(!$showThumbnails){
            ?>
            #bxslider_overlay, .slider {
                visibility: hidden !important;
            }

            <?php
            }
            ?>
        </style>
        <?php
        $head_styles .= ob_get_clean();
    }

    if ($openflipbook == $currentModuleID) { // this is a GET variable
        ?>
        <div class="flipbook-viewport">
            <div class="container">
                <div class="flipbook">
                    <div ignore="1" class="next-button"></div>
                    <div ignore="1" class="previous-button"></div>
                </div>
            </div>
        </div>
        <div id="bxslider_overlay"></div>
        <div class="slider" style="margin:0 auto;">
            <ul class="bxslider">
                <?php
                $counter = 0;
                foreach ($thumbs as $thumb) {
                    $counter++;
                    ?>
                    <a rel="gallery" data-index="<?php echo $counter; ?>"><img src="<?php echo $thumb; ?>" width="50px" height="65px"/></a>
                    <?php
                }
                ?>
            </ul>
            <?php
            if($pdf){
                ?>
                <a class="flipbook_pdf_download"  href="<?php echo $pdf; ?>" target="_blank"><img src="<?php echo $mp; ?>images/pdf_download.png" alt=""></a>

                <?php
            }
            ?>
        </div>

        <script>
            var images = ['<?php echo implode("','", $pages);?>'];
            var large_images = ['<?php echo implode("','", $large_pages);?>'];
            var numOfPages = <?php echo count($pages);?>;
            var pageWidth = <?php echo $pageWidth;?>;
            var bookWidth = pageWidth * 2;
            var bookHeight = <?php echo $pageHeight;?>;
            var thumbWidth = 50;
            var maxSlides = getMaxSlides();
            var $slider;
            var w;

            jQuery().ready(function () {
                var content = $('#<?php echo $mn . $sufixID;?>');
                content.css({
                    'position': 'absolute',
                    'top': '0',
                    'left': '0',
                    'width': '100%',
                    'height': '100%',
                    'background-color': '#<?php echo $backgroundColor;?>',
                    'z-index': '9998'
                });
                content.parents().css('position', 'static');
                $('body').css({'overflow-y': 'hidden'});
                $('.slider').css("display", "block");
                $('.slider').css('margin-top', "-80px");
                $('.bxslider').css('z-index', "9999");

                $(window).on("orientationchange resize", configureSlider);
                configureSlider(); // initialize thumbs

                if (numOfPages <= window.maxSlides) {
                    $('.bx-prev').hide();
                    $('.bx-next').hide();
                }
                $('.bxslider').find('a').each(function () {
                    $(this).click(function () {
                        $('.flipbook').turn('page', $(this).attr('data-index'));
                    }).css('cursor', 'pointer');
                    if ($(this).attr('data-index') % 2 == 0) $(this).css('margin-right', '0');
                });
            });

            function buildSliderConfiguration() {
                maxSlides = getMaxSlides();
                maxSlides = (numOfPages == maxSlides + 1) ? maxSlides - 1 : maxSlides;
                w = (numOfPages > maxSlides) ? (thumbWidth * maxSlides) + (3 * maxSlides) : (thumbWidth * numOfPages) + (3 * maxSlides);
                $('.slider').css('width', w + "px");
                return {
                    autoControls: false,
                    hideControlOnEnd: false,
                    infiniteLoop: false,
                    pager: false,
                    minSlides: 1,
                    maxSlides: maxSlides,
                    slideWidth: thumbWidth,
                    slideMargin: 3
                };
            }

            function getMaxSlides() {
                var windowWidth = $(window).width();
                var numberOfVisibleSlides;
                if (windowWidth < 500) {
                    numberOfVisibleSlides = 3;
                }
                else if (windowWidth < 610) {
                    numberOfVisibleSlides = 5;
                }
                else if (windowWidth < 800) {
                    numberOfVisibleSlides = 7;
                }
                else if (windowWidth < 1200) {
                    numberOfVisibleSlides = 11;
                }
                else {
                    numberOfVisibleSlides = 18;
                }
                console.log(numberOfVisibleSlides);
                return numberOfVisibleSlides;
            }

            function configureSlider() {
                var config = buildSliderConfiguration();
                if ($slider && $slider.reloadSlider) {
                    $slider.reloadSlider(config);
                }
                else {
                    $slider = $('.bxslider').bxSlider(config);
                }
            }

            $('.slider-prev').click(function () {
                var current = $slider.getCurrentSlide();
                $slider.goToPrevSlide(current) - 1;
            });
            $('.slider-next').click(function () {
                var current = $slider.getCurrentSlide();
                $slider.goToNextSlide(current) + 1;
            });


            function loadApp() {
                $('.flipbook').turn({
                    width: bookWidth,
                    height: bookHeight,
                    elevation: 50,
                    acceleration: !isChrome(),
                    gradients: true,
                    autoCenter: true,
                    pages: numOfPages,
                    when: {
                        turning: function (event, page, view) {
                            var book = $(this),
                                currentPage = book.turn('page'),
                                pages = book.turn('pages');
                            Hash.go('page/' + page).update();
                            $('[data-index]').each(function () {
                                $(this).removeClass('thumb_current');
                            });
                            $slider.goToSlide(Math.floor(page / maxSlides));
                            $('[data-index="' + page + '"]').addClass('thumb_current');
                            if (page % 2 == 0) {
                                $('[data-index="' + (page + 1) + '"]').addClass('thumb_current');
                            } else {
                                $('[data-index="' + (page - 1) + '"]').addClass('thumb_current');
                            }
                            $('.bx-viewport').css("height", "auto");
                        },
                        turned: function (event, page, view) {
                            $(this).turn('center');
                            if (page == 1) {
                                $(this).turn('peel', 'br');
                                $(this).turn('peel', 'tr')
                            }
                        },
                        missing: function (event, pages) {
                            for (var i = 0; i < pages.length; i++)
                                addPage(pages[i], $(this));
                        }
                    }
                });
                $('.flipbook-viewport').zoom({
                    flipbook: $('.flipbook'),
                    max: function () {
                        return largeFlipbookWidth() / $('.flipbook').width();
                    },
                    when: {
                        tap: function (event) {
                            if ($(this).zoom('value') == 1) {
                                $('.flipbook').removeClass('animated').addClass('zoom-in');
                                $(this).zoom('zoomIn', event);
                            } else {
                                $(this).zoom('zoomOut');
                            }
                        },
                        resize: function (event, scale, page, pageElement) {
                            if (scale == 1)
                                loadSmallPage(page, pageElement);
                            else
                                loadLargePage(page, pageElement);
                        },
                        zoomIn: function () {
                            $('#bxslider_overlay').hide();
                            $('.slider').hide();
                            $('.flipbook').addClass('zoom-in');
                            if (!window.escTip && !$.isTouch) {
                                escTip = true;
                                $('<div />', {'class': 'esc'}).html('<div>Press ESC to exit</div>').appendTo($('body')).delay(2000).animate({opacity: 0}, 500, function () {
                                    $(this).remove();
                                });
                            }
                        },
                        zoomOut: function () {
                            $('.esc').hide();
                            $('#bxslider_overlay').fadeIn();
                            $('.slider').fadeIn();
                            setTimeout(function () {
                                $('.flipbook').addClass('animated').removeClass('zoom-in');
                                resizeViewport();
                            }, 0);
                        },
                        swipeLeft: function () {
                            $('.flipbook').turn('next');
                        },
                        swipeRight: function () {
                            $('.flipbook').turn('previous');
                        }
                    }
                });
                $(document).keydown(function (e) {
                    var previous = 37, next = 39, esc = 27;
                    switch (e.keyCode) {
                        case previous:
                            $('.flipbook').turn('previous');
                            e.preventDefault();
                            break;
                        case next:
                            $('.flipbook').turn('next');
                            e.preventDefault();
                            break;
                        case esc:
                            $('.flipbook-viewport').zoom('zoomOut');
                            e.preventDefault();
                            break;
                    }
                });
                Hash.on('^page\/([0-9]*)$', {
                    yep: function (path, parts) {
                        var page = parts[1];
                        if (page !== undefined) {
                            if ($('.flipbook').turn('is'))
                                $('.flipbook').turn('page', page);
                        }
                    },
                    nop: function (path) {
                        if ($('.flipbook').turn('is'))
                            $('.flipbook').turn('page', 1);
                    }
                });
                $(window).resize(function () {
                    resizeViewport();
                }).bind('orientationchange', function () {
                    resizeViewport();
                });

                $('.next-button').bind($.mouseEvents.over, function () {
                    $(this).addClass('next-button-hover');
                }).bind($.mouseEvents.out, function () {
                    $(this).removeClass('next-button-hover');
                }).bind($.mouseEvents.down, function () {
                    $(this).addClass('next-button-down');
                }).bind($.mouseEvents.up, function () {
                    $(this).removeClass('next-button-down');
                }).click(function () {
                    $('.flipbook').turn('next');
                });
                $('.previous-button').bind($.mouseEvents.over, function () {
                    $(this).addClass('previous-button-hover');
                }).bind($.mouseEvents.out, function () {
                    $(this).removeClass('previous-button-hover');
                }).bind($.mouseEvents.down, function () {
                    $(this).addClass('previous-button-down');
                }).bind($.mouseEvents.up, function () {
                    $(this).removeClass('previous-button-down');
                }).click(function () {
                    $('.flipbook').turn('previous');
                });
                resizeViewport();
                $('.flipbook').addClass('animated');
            }

            yepnope({
                test: Modernizr.csstransforms,
                yep: ['<?php echo $mp;?>/js/turn.min.js'],
                nope: ['<?php echo $mp;?>/js/turn.html4.min.js'],
                both: ['<?php echo $mp;?>/js/zoom.min.js'],
                complete: loadApp
            });
        </script>


    <?php
    $_SESSION['flipbookAutoOpened'] = false;
    }else{ // end if $openflipbook
    ?>
        <script>
            jQuery().ready(function () {
                $('a[data-rel="openflipbook"]').fancybox({
                    onClosed: function () {
                    },
                    'opacity': 0,
                    'overlayColor': '#000',
                    'width': '100%',
                    'height': '100%',
                    'fitToView': true,
                    'autoSize': false,
                    'autoScale': false,
                    'transitionIn': 'elastic',
                    'transitionOut': 'elastic',
                    'type': 'iframe',
                    'showNavArrows': false,
                    'titleShow': false
                });
                <?php
                if($autoLoad){
                if(!$_SESSION['flipbookAutoOpened']){
                ?>
                $('#link<?php echo $sufixID;?>').click();
                <?php
                $_SESSION['flipbookAutoOpened'] = true;
                }
                }
                ?>
            });
        </script>
        <div class="book_opener">
            <?php
            if (!empty($bookDescription)) echo htmlspecialchars_decode($variables->restoreModuleValue($bookDescription));
            ?>
            <div>
                <a id="link<?php echo $sufixID; ?>" data-rel="openflipbook" href="<?php echo $_SERVER['REQUEST_URI']; ?>&openflipbook=<?php echo $currentModuleID; ?>"><img src="<?php echo $mp; ?>images/openflipbook.png" width="173" height="50" alt="open flipbook"/></a>
            </div>
        </div>
        <?php
    }
    if ($useModuleContainer){
    ?>
</div>
<?php
}
?>
